<?php
# Copyright (c) 2006 Skyline-arts.com. All rights reserved.

# Classe Admin #
class admin extends pluxml{

	var $config; # Tableau de configuration
	var $racine; # Url de Pluxml
	var $all_files; # Tableau de tous les fichiers
	var $next_id; # Numero du prochain article
	var $magic_quote; # Etat des 'magic_quote'

	var $cat_all; # Tableau de toutes les catgories
	var $cat_used; # Tableau des catgories utilises


	function admin($file_config, $file_cat){

		$this->config = $this->parseConfig($file_config);
		$this->racine = $this->config['racine'];
		$motif = '/^[0-9]{4}.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/';
		$this->all_files = _glob('../../'.$this->config['racine_xml'],$motif);
		if($this->all_files){ rsort($this->all_files); }
		$this->next_id = $this->nextId('../../'.$this->config['racine_xml'],'/(.*).(.*)(.[a-z-])*.xml$/');
		$this->magic_quote = get_magic_quotes_gpc();

		$this->cat_all = $this->parseCategorie($file_cat);
	}


	function cleanUrl(){

		for($i=0;$i<sizeof($this->all_files);$i++){
			$url_explode = explode('/',$this->all_files[$i]);
			$this->all_files[$i] = $url_explode[count($url_explode)-1];
		}
	}


	function contentEdit($file, $array_content){

		# Traitement des magic_quote
		$array_content = $this->slash($array_content);
		if($array_content['url'] == ''){
			$array_content['url'] = title2url($array_content['titre']);
		}else{
			$array_content['url'] = title2url($array_content['url']);
			}

		 # Vrification de l'intgrit de l'identifiant
		if(ereg("^[0-9]{4}$",$file)){
$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>
<document>

	<infopost>
		<title>".htmlspecialchars($array_content['titre'])."</title>
		<author>".$array_content['auteur']."</author>
		<date>".$array_content['year'].'-'.$array_content['month'].'-'.$array_content['day'].'T'.$array_content['time'].$this->config['delta']."</date>
	</infopost>
	<chapo>
		<![CDATA[".$array_content['chapo']."]]>
	</chapo>
	<content>
		<![CDATA[".$array_content['contenu']."]]>
	</content>

</document>";

		if($array_content['old_cat'] != NULL){ # Si c'est une dition
			$glob = _glob('../../'.$this->config['racine_xml'],'/'.$file.'.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/');
			unlink($glob[0]);
			if($this->write($xml, '../../'.$this->config['racine_xml'].$file.'.'.$array_content['cat_num'].'.'.$array_content['url'].'.xml')){
				return 'Article modifi';
			}else{
				return 'Erreur lors de la cration de l\'article';
			}
		}else{
			if($this->write($xml, '../../'.$this->config['racine_xml'].$file.'.'.$array_content['cat_num'].'.'.$array_content['url'].'.xml')){
				return 'Article cr';
			}else{
				return 'Erreur lors de la cration de l\'article';
			}
		}

	}else{
		return 'Fichier non valide';
		}
	}


	function editCategories($content){

		$content = $this->slash($content);
		$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>
<document>\n";

		foreach($content as $cat_num => $cat_name){
		
			if(is_numeric($cat_num) & $cat_name != ''){
			
				$cat_ord = $content[$cat_num.'_ord'];
				if(isset($content[$cat_num.'_url']) && $content[$cat_num.'_url'] != ''){
					$cat_url = cat2url($content[$cat_num.'_url']);
				}else{
					$cat_url = cat2url($cat_name);
				}
			
$xml .= "\t<categorie number=\"".$cat_num."\" ordre=\"".$cat_ord."\" url=\"".$cat_url."\">".$cat_name."</categorie>\n";
			}
		}
		$xml .= "</document>";

		if($this->write($xml, '../conf/categorie.xml')){
			return 'Catgories modifies';
		}else{
			return 'Erreur dans la modification du fichier "categorie.xml"';
		}
	}


	function editConfiguration($content){

		if(!empty($content['version']) && !empty($content['titre']) && !empty($content['racine'])
		&& !empty($content['racine_xml']) && !empty($content['delta']) && !empty($content['bypage_rss'])
		&& !empty($content['bypage']) && !empty($content['style'])){
			$content = $this->slash($content);
	$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>
<document>
	<parametre name=\"version\">".$content['version']."</parametre>
	<parametre name=\"title\">".$content['titre']."</parametre>
	<parametre name=\"description\">".$content['sous-titre']."</parametre>
	<parametre name=\"racine\">".$content['racine']."</parametre>
	<parametre name=\"racine_xml\">".$content['racine_xml']."</parametre>
	<parametre name=\"delta\">".$content['delta']."</parametre>	
	<parametre name=\"bypage_rss\">".$content['bypage_rss']."</parametre>
	<parametre name=\"bypage\">".$content['bypage']."</parametre>
	<parametre name=\"style\">".$content['style']."</parametre>
</document>";

			if($this->write($xml, '../conf/config.xml')){
				return 'Configuration modifie';
			}else{
				return 'Erreur dans la modification du fichier "config.xml"';
			}
		}else{
			return 'Tous les champs obligatoire ne sont pas remplis';
		}
	}


	function delete($file){
		if(ereg("^[0-9]{4}\.([0-9]{3}|home)(.[a-z0-9-]*)*\.xml$",$file)){
			unlink('../../'.$this->config['racine_xml'].'/'.$file);
		}
		if(file_exists('../../'.$this->config['racine_xml'].'/'.$file)){
			return "L'article n'a pas pu tre supprim";
		}else{
			return 'Article supprim';
		}
	}


	function slash($content){

		if($this->magic_quote == 1){
			if(is_array($content)){
				foreach($content as $key => $data) {
					$new_content[$key] = stripslashes($data);
				}
			}else{
				$new_content = stripslashes($content);
			}
			return $new_content;
		}else{
			return $content;
		}
	}

	function write($xml, $filename){

		if(file_exists($filename)){
			$f=fopen($filename.'.tmp', 'w'); # On ouvre le fichier temporaire
			fwrite($f, trim($xml)); # On crit
			fclose($f); # On ferme
			unlink($filename);
			rename($filename.'.tmp', $filename); # On renomme le fichier temporaire avec le nom de l'ancien
		}else{
			$f=fopen($filename, 'w'); # On ouvre le fichier
			fwrite($f, trim($xml)); # On crit
			fclose($f); # On ferme
		}
		if(file_exists($filename) && !file_exists($filename.'.tmp')){
			return true;
		}else{
			return false;
		}

	}

	function nextId($dir, $pattern){

		$array = _glob($dir,$pattern);
		if(!$this->all_files){
			return '0001';
		}
		rsort($array);
		return str_pad(fileInfo($array['0'],'fileId')+1,4, "0", STR_PAD_LEFT);
	}

}
