<?php
# Copyright (c) 2006 Skyline-arts.com. All rights reserved.

# Classe Pluxml #
class pluxml{

	var $chr_start; # Microtime du dbut de l'execution

	var $config; # Tableau de configuration
	var $style; # Dossier contenant le thme
	var $racine; # Url de Pluxml
	var $bypage; # Nombre d'articles par page

	var $cat_all; # Tableau de toutes les catgories
	var $cat_used; # Tableau des catgories utilises

	var $pagination; # Numro de la page
	var $mode; # Mode
	var $motif; # Motif de recherche

	var $all_files; # Tableau de tous les fichiers
	var $a_file_cat; # Tableau des fichiers de la catgories
	var $a_file; # Tableau de fichiers  traiter

	var $a_article; # Tableau d'articles  afficher
	var $a_index; # Index du tableau des articles

	function pluxml($file_config, $file_cat, $xml=''){

		$this->chr_start = date::ext_microtime();

		if(!empty($_GET)){
		foreach($_GET as $k => $v){$this->get = $k;}
		}else{$this->get = '';}
		
		$this->config = $this->parseConfig($file_config);
		$this->cat_all = $this->parseCategorie($file_cat);
		$this->racine = $this->config['racine'];
		$this->bypage =$this->config['bypage'];
		$this->style = $this->config['style'];
		
		if($xml != ''){
			$this->config['racine_xml'] = $xml;
		}
		
		$this->all_files = _glob($this->config['racine_xml'],'/^[0-9]{4}.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/');
		$this->a_index = -1;
	}

	function parseConfig($url_file){

		$data = implode("",file($url_file));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		for($i=0;$i < count($index_tags['parametre']);$i++) {
			if(isset($valeurs[$index_tags['parametre'][$i]]['value'])){
				$array[$valeurs[$index_tags['parametre'][$i]]['attributes']['name']] =
				htmlspecialchars($valeurs[$index_tags['parametre'][$i]]['value']);
			}else{
				$array[$valeurs[$index_tags['parametre'][$i]]['attributes']['name']] = '';
			}
		}
		return $array;
	}

	function parseCategorie($url_file){

		$data = implode("",file($url_file));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		if(isset($index_tags['categorie'])){
		for($i=0;$i < count($index_tags['categorie']);$i++) {
			$array[$valeurs[$index_tags['categorie'][$i]]['attributes']['number']]['name']
			= $valeurs[$index_tags['categorie'][$i]]['value'];
			$array[$valeurs[$index_tags['categorie'][$i]]['attributes']['number']]['url']
			= $valeurs[$index_tags['categorie'][$i]]['attributes']['url'];
		}
		for($i=0;$i < count($index_tags['categorie']);$i++) {
			$ordre[$valeurs[$index_tags['categorie'][$i]]['attributes']['ordre']]
			= $valeurs[$index_tags['categorie'][$i]]['attributes']['number'];
		}
		ksort($ordre);
		foreach($ordre as $key => $values) {
			if(array_key_exists($values, $array)){
				$final[$values]['name'] = $array[$values]['name'];
				$final[$values]['url'] = $array[$values]['url'];
				$final[$values]['ordre'] = $key;
			}
		}
		return $final;
		}
	}

	function usedCategorie($prefixe=''){

		$array = array();
		foreach($this->cat_all as $num => $info){
			$motif = '/^[0-9]{4}.'.$num.'(.[a-z0-9-]*)*.xml$/';
			if( _glob($prefixe.$this->config['racine_xml'],$motif) ){
				$array[$num] = $this->cat_all[$num];
			}
		}
		return $array;
	}

	function mode($force=''){
	
		if($force=='syndic'){
			$this->mode = 'syndic';
			$this->motif = '/^[0-9]{4}.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/';
		}
		elseif(preg_match('/^([0-9]*)-/',$this->get,$capture)){
			$capture['1'] = str_pad($capture['1'],4, "0", STR_PAD_LEFT);
			$this->mode = 'article';
			$this->motif = '/'.$capture['1'].'.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/';
		}
		elseif(preg_match('/^([0-9]{3})\/([A-Z]*)/',$this->get,$capture)){
			$this->mode = 'cat';
			$this->motif = '/^[0-9]{4}.'.$capture['1'].'(.[a-z0-9-]*)*.xml$/';
			$this->arrayArticlesCat();
		}else{
			$this->mode = 'home';
			if(_glob($this->config['racine_xml'],'/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/')){
				$this->motif = '/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/';
			}else{
				$this->motif = '/[0-9]{4}.[0-9]{3}(.[a-z0-9-]*)*.xml$/';
			}
		}
	}

	function pagination($bypage=''){

		if($bypage==''){
			$bypage = $this->bypage;
		}
		if (preg_match('/page([0-9]*)/',$this->get,$capture)){
			$this->pagination = $capture[1];
		}else{
			$this->pagination = 1;
		}
		if($this->motif == '/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/'){
			return;
		}
		$this->a_file = array_slice($this->a_file,$this->pagination*$bypage-$bypage,$bypage);
	}

	function arrayFiles(){

		$this->a_file = _glob($this->config['racine_xml'],$this->motif);
		rsort($this->a_file);
	}

	function arrayArticlesCat(){

		$this->a_file_cat = _glob($this->config['racine_xml'],$this->motif);
		rsort($this->a_file_cat);
	}

	function arrayArticles(){

		for($i=0;$i<sizeof($this->a_file);$i++) {
		$this->a_article[$i] = $this->parseArticle($this->a_file[$i]);
		}
	}

	function parseArticle($filename){

		$data = implode("",file($filename));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		$publication['title'] = $valeurs[$index_tags['title']['0']]['value'];
		$publication['author'] = $valeurs[$index_tags['author']['0']]['value'];
		$publication['date'] = $valeurs[$index_tags['date']['0']]['value'];
		$publication['filename'] = $filename;
		$publication['cat_num'] = fileInfo($filename, 'catId');
		$publication['file_num'] = fileInfo($filename, 'fileId');
		$publication['art_name'] = fileInfo($filename, 'artname');
		if(trim($valeurs[$index_tags['chapo']['0']]['value']) !== ''){
			$publication['chapo'] = $valeurs[$index_tags['chapo']['0']]['value'];
		}else{
			$publication['chapo'] = '';
		}
		$publication['content'] = $valeurs[$index_tags['content']['0']]['value'];
		$publication['size'] = filesize($filename);

		return $publication;
	}

	function loopArticles(){

		if($this->a_index < count($this->a_article)-1){
			$this->a_index++;
			return true;
		}else{
			return false;
		}
	}

}
?>