<?php
# Copyright (c) 2006 Skyline-arts.com. All rights reserved.

class date{

	function ext_microtime(){
	
	$t = explode(' ',microtime());
	return $t[0]+$t[1];
	}

	# dateRss2Hum
	# A partir d'une date au format Iso, retourne 'jour' 'num du jour' 'mois' 'anne'
	function dateIso2Hum($date_iso){

	$year = substr($date_iso, 0, 4);
	$month = substr($date_iso, 5, 2);
	$day = substr($date_iso, 8, 2);
	$day_num = date('w',mktime(0, 0, 0, $month, $day, $year));

	$ar_month = array(
		'01' => 'janvier','02' => 'fvrier','03' => 'mars','04' => 'avril','05' => 'mai','06' => 'juin',
		'07' => 'juillet','08' => 'aot','09' => 'septembre','10' => 'octobre','11' => 'novembre','12' => 'dcembre');

	$ar_day = array(
		'1' => 'Lundi','2' => 'Mardi','3' => 'Mercredi',
		'4' => 'Jeudi','5' => 'Vendredi','6' => 'Samedi','0' => 'Dimanche');

	return ''.$ar_day[$day_num].' '.$day.' '.$ar_month[$month].' '.$year.'';
	}
	
	# heureRss2Hum
	# A partir d'une date au format Iso, retourne 'heure':'minute'
	function heureIso2Hum($date_iso){

	$hours = substr($date_iso, 11, 2);
	$min = substr($date_iso, 14, 2);
	return ''.$hours.':'.$min.'';
	}
	
	# heureIso2Admin
	# Spare les lments d'une date Iso et les met dans un tableau
	function heureIso2Admin($date){

	preg_match('/([0-9]{4})-([0-9]{2})-([0-9]{2})T([0-9:]{8})((\+|-)[0-9:]{5})/',$date,$capture);
	return array (
		'year' => $capture[1],'month' => $capture[2],
		'day' => $capture[3],'time' => $capture[4],'delta' => $capture[5],);
	}
}

class form{

	function select($name, $array, $selected=''){
		echo "<select name=\"$name\">\n";
		foreach($array as $a => $b) {
			if($a == $selected) {
				echo "\t\t<option value=\"$a\" selected=\"selected\">$b</option>\n";
			}else{
				echo "\t\t<option value=\"$a\">$b</option>\n";
			}
		}
		echo "\t</select>\n\n";
	}

	function input($name, $value='', $type, $size='', $max=''){

		echo "<input name=\"$name\" type=\"$type\" size=\"$size\" maxlength=\"$max\" value=\"$value\" />\n";
	}

	function area($name, $value='', $cols='', $rows=''){

		echo "<textarea name=\"$name\" cols=\"$cols\" rows=\"$rows\">$value</textarea>\n\n";
	}
}

function analysePwd($filename){

		$data = implode("",file($filename));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		for($i=0;$i < count($index_tags['user']);) {
			$array[$valeurs[$index_tags['user'][$i]]['attributes']['login']] = $valeurs[$index_tags['user'][$i]]['value'];
		$i++;
		}

		return $array;
}


# _glob
# Retourne un tableau contenant les fichiers vrifiant le masque
function _glob($dir, $motif, $doc=''){

	$dh = opendir($dir);
	while (false !== ($file = readdir($dh))) {
		if($doc == 1){
			if(is_dir($dir.'/'.$file) && !preg_match('/^(.|..)$/',$file)){
				if(preg_match($motif,$file,$capture)){
					$array[] = $capture[0];
				}
			}
		}
		else{
			if(preg_match($motif,$file,$capture)){
			$array[] = $dir.$capture[0];
			}
		}
	}
	closedir($dh);
	if(isset($array)){
		return $array;
	}else{
		return false;
	}
}


# fileInfo
# Suivant l'attribut 'output', retourne le numro d'article ou de catgorie d'un fichier
function fileInfo($filename, $output){

	if(preg_match('/([0-9]{4}).([0-9]{3}|home)(.([a-z0-9-]*))*.xml$/',$filename,$capture)){
		if ($output == 'fileId'){
			return $capture[1];
		}
		if ($output == 'catId'){
			return $capture[2];
		}
		if ($output == 'artname'){
			return $capture[4];
		}
	}
}


# test_write
# Vrifie si le fichier est accessible en criture
function test_write($file){

	if(is_writable($file)){
		echo $file.' est accessible en criture';
	}else{
		echo $file.' n\'est pas accessible en criture';
	}

}

function title2url($str){

	$str = strtolower($str);
	$str = strtr($str,
	"",
	"AAAAAAaaaaaaCcOOOOOOooooooEEEEeeeeIIIIiiiiUUUUuuuuYYyyNn");
	$str = preg_replace('/[\"\s\'\:\/\[\].-]+/',' ',$str);
	return strtr(trim($str), ' ', '-');
}

function cat2url($str){

	return ucfirst(title2url($str));
}
?>
